// this is an adjacency list of the board for all PLAIN areas
// this is used to find the shortest path from any node to another
import java.util.*;

public class BoardGraph{
	private ArrayList list;
	
	// build a graph off of the whole board
	public BoardGraph(TheBoard board){
		list = new ArrayList();
		for(int i=1; i<=board.getHeight(); i++){
			for(int j=1; j<=board.getWidth(); j++){
				String sym = board.getSymbol(j,i);
				if(sym.equals(TheBoard.BASE)){
					board.acknowledgeBase(new BoardNode(j,i));
				}
				if(!(sym.equals(TheBoard.WATER)) && !(sym.equals(TheBoard.WALL))){
					list.add(new BoardNode(j, i));
				}
			}
		}
		assignAdjacencies();
	}
	
	public ArrayList getList(){return list;}
	
	public void assignAdjacencies(){
		Iterator it = list.iterator();
		while(it.hasNext()){
			BoardNode n = (BoardNode)it.next();
			n.addChild(neighbor(n, BoardNode.N), BoardNode.N);
			n.addChild(neighbor(n, BoardNode.S), BoardNode.S);
			n.addChild(neighbor(n, BoardNode.E), BoardNode.E);
			n.addChild(neighbor(n, BoardNode.W), BoardNode.W);
		}
	}
	
	// REMEMBER!  North is really down....
	private BoardNode neighbor(BoardNode node, int relationship){
		int idx = -1;
		BoardNode n;
		switch(relationship){
			case BoardNode.N:
				n = new BoardNode(node.getX(), node.getY()+1);
				idx = list.indexOf(n);
				break;
			case BoardNode.S:
				n = new BoardNode(node.getX(), node.getY()-1);
				idx = list.indexOf(n);
				break;
			case BoardNode.E:
				n = new BoardNode(node.getX()+1, node.getY());
				idx = list.indexOf(n);
				break;
			case BoardNode.W:
				n = new BoardNode(node.getX()-1, node.getY());
				idx = list.indexOf(n);
				break;
		}
		if(idx==-1)
			return null;
		else
			return (BoardNode)list.get(idx);
	}
	
}
