public class BoardNode{
	private int x;
	private int y;
	// REMEMBER, north is down!
	private BoardNode north, south, east, west;
	public static final int N=0, S=1, E=2, W=3;
	public static final int WHITE=0;
	public static final int GREY=1;
	public static final int BLACK=2;
	// some stuff for making the depth first easier
	public int color;
	public int dist;
	public int pred;
	
	public BoardNode(int x, int y){
		this.x=x;
		this.y=y;
		color = WHITE;
		dist = Integer.MAX_VALUE;
		pred = -1;
	}
	
	public boolean equals(Object o){
		if(o instanceof BoardNode){
			BoardNode b = (BoardNode)o;
			return (b.x==x)&&(b.y==y);
		}else{
			return false;
		}
	}
	
	public boolean equals(int x, int y){
		return (this.x==x)&&(this.y==y);
	}
	
	public int getX(){return x;}
	public int getY(){return y;}
	
	public void addChild(BoardNode n, int relationship){
		switch(relationship){
			case N:
				north = n;
				break;
			case S:
				south=n;
				break;
			case E:
				east = n;
				break;
			case W:
				west = n;
				break;
		}
	}
	
	
	public BoardNode getChild(int relationship){
		switch(relationship){
			case N:
				return north;
			case S:
				return south;
			case E:
				return east;
			case W:
				return west;
		}
		return null;
	}
	
	public BoardNode getNorth(){return north;}
	public BoardNode getSouth(){return south;}
	public BoardNode getEast(){return east;}
	public BoardNode getWest(){return west;}
	
	
}
