/*
	OK, here is where we put the general strategy stuff of how we're playing the game.
	There needs to be a Thread going on in whats now the Robot Main to deal with
	the server I/O stuff.  I need to have a Queue over here that is taking responses
	from the server thread.
	//
	Did a bit of looking into it, the non-fractional knapsack problem is NP hard!
	SO...i'm going to do a reverse greedy strategy: pick up packages in ascending
	order of their weight.  This should give me as many packages as possible, so 
	that if somebody pushes me it won't cost much and i can just run away.
	// 
	i think i could get away with making this class a separate thread, but i think
	what i'll do is use the "main" thread as this thread.
	//
	OK....
	ALL THE BASICS ARE HERE, I JUST NEED TO HAVE SOME SORT OF ACTUAL GAME STRATEGY
	GOING ON, SOMETHING THAT DECIDES WHAT COMMANDS I'M SUPPOSED TO SEND.
	////
	Starting to get a little late now!!  I've decided on trying to model desires
	and intentions for the robot.  Following a sort of "hierarchy of need" the 
	robot first sees to his safety, resorting to FIGHT or FLEE as necessary.  If 
	he's safe then he satisfies his GREED, if satiated then he implements SPEED to
	get to the nearest base and get the accolades of his peers.
*/
import java.util.*;
import java.io.*;

public class GamePlay implements Runnable{
	private Queue msgs;
	private ArrayList botList;
	// guessing some stuff here
	private TheRobot avatar;
	private TheBoard universe;
	//private ArrayList myPackages;
	//private PackageTable myPkgIndex;
	private ArrayList knownPackages;
	private PackageTable knownPkgIndex;
	private ArrayList availablePackages;
	private LinkedList currentPlan;
	public static final int TURN = 0;
	public static final int PACKAGES = 1;
	// need the 'out' to transmit desired moves!
	private BufferedWriter out;
	
	private boolean havePlan;
	private boolean init;
	private int[] baseWeights;
	private int homeBase;
	// threat levels
	public static final int GREEN = 0;
	public static final int YELLOW = 1;
	public static final int RED = 2;
	
	private boolean mustDeliverPackages;
	
	private Thread runner = null;
	public GamePlay(TheRobot avatar, TheBoard universe, BufferedWriter out){
		msgs = new Queue();
		botList = new ArrayList();
		this.avatar = avatar;
		botList.add(avatar);
		this.universe = universe;
		this.out = out;
		havePlan = false;
		init = false;
		mustDeliverPackages = false;
		currentPlan = new LinkedList();
		baseWeights = new int[universe.getBases().size()];
		//myPackages = new ArrayList();
		//myPkgIndex = new PackageTable();
		knownPackages = new ArrayList();
		knownPkgIndex = new PackageTable();
		availablePackages = new ArrayList();
		//playGame();
		runner = new Thread(this);
		runner.start();
	}
	
	public synchronized void passMessage(String msg){
		msgs.enqueue(msg);
		notify();
	}
	
	public void run(){
		playGame();
	}
	
	private synchronized void playGame(){
		while(true){
			if(msgs.isEmpty()){
				try{
					wait();
				}catch(Exception e){
					System.err.println("Some kind of screwy thread exception just happened...:");
					e.printStackTrace();
				}
			}else{
				if(interpretMessage((String)msgs.dequeue())==PACKAGES){
					figureOutACommand();
				}//otherwise we've just been given state info, a package list will shortly follow
			}
		}
	}
	
	private void sendCommandToServer(String cmd){
		try{
			System.out.println("current position:" + avatar.getX() + " " + avatar.getY());
			System.out.println(cmd);
			out.write(cmd+"\n");
			out.flush();
		}catch(IOException ioe){
			System.err.println("Son-of-a...looks like i got some IOException issuing a command to the server:");
			ioe.printStackTrace();
		}
	}
	
	// here is where we do a Move, Pick, or Drop
	private void figureOutACommand(){
		if(!init){
			consultMap();
			init = true;
		}
		int threatLevel = checkThreats();
		switch(threatLevel){
			case GREEN:
				if(mustDeliverPackages){
					moveToNearestBase();
				}else{
					if(!checkForDropCondition(GREEN)){
						desirePackages();
					}
				}
				break;
			case YELLOW:
				if(mustDeliverPackages){
					moveToNearestBase();
				}else{
					if(!checkForDropCondition(YELLOW)){
						desireFight();
					}
				}
				break;
			case RED:
				desireFlee();
				break;
		}
		//sublimateDesires();
	}
	
	private boolean justDropped = false;
	private boolean checkForDropCondition(int threat){
		//if(universe.getSymbol(avatar.getX(), avatar.getY()).equals(TheBoard.BASE) && !justDropped){
		//int s = avatar.getKnapsack().getPackages(new BoardNode(avatar.getX(), avatar.getY())).size();
		BoardNode base = new BoardNode(avatar.getX(), avatar.getY());
		ArrayList pkgs = getPackagesForBase(base);
		int s = pkgs.size();
		if(universe.getSymbol(avatar.getX(), avatar.getY()).equals(TheBoard.BASE) && s>0){
			//BoardNode base = new BoardNode(avatar.getX(), avatar.getY());
			//ArrayList pkgs = getPackagesForBase(base);
			//ArrayList pkgs = avatar.getKnapsack().getPackages(base);
			int bid = 1;
			String cmd = "";
			if(threat!=GREEN && pkgs.size()>0)
				bid = makeHiBid();
			cmd += bid + " Drop ";
			Iterator it = pkgs.iterator();
			while(it.hasNext()){
				ThePackage pk = (ThePackage)it.next();
				cmd += cmd + pk.getID() + " ";
			}
			justDropped = true;
			if(pkgs.size()==0){
				return false;
			}else{
				mustDeliverPackages = false;
	System.out.println("issuing a drop command:");
				sendCommandToServer(cmd);
				return true;
			}
		}else{
			justDropped = false;
			if(universe.getSymbol(avatar.getX(), avatar.getY()).equals(TheBoard.BASE) && s==0){
				consultMap();
				if(baseWeights.length>1)
					homeBase = secondSmallest(baseWeights);
				currentPlan = ShortestPath.getShortestPath(universe.getGraph(), new BoardNode(avatar.getX(), avatar.getY()), (BoardNode)universe.getBases().get(homeBase));
			}
			return false;
		}
		//return false;
	}
	
	private ArrayList getPackagesForBase(BoardNode base){
		ArrayList ans = new ArrayList();
		Iterator it = avatar.getPackageList().iterator();
		while(it.hasNext()){
			ThePackage pkg = (ThePackage)it.next();
			if(pkg.getDestination().equals(base))
				ans.add(pkg);
		}
		return ans;
	}
	
	private int secondSmallest(int[] foo){
		int smallest=0, secondSmallest = 0;
		for(int i=0; i<foo.length; i++){
			if(foo[i]<smallest){
				secondSmallest = smallest;
				smallest = i;
			}
		}
		return secondSmallest;
	}
	
	private void desirePackages(){
		if(packagesPresent()){
			if(feelGreedy()){
				takePackagesIWant();
			}else{
				moveToNearestBase();
			}
		}else{
			if(feelGreedy()){
				lookAround();
			}else{
				moveToNearestBase();
			}
		}
	}
	
	// search off the explicit path for more packages
	// rather than do something smart and cool, i'll just do something random
	public void lookAround(){
		String[] dirs = new String[4];
		String[] ans = {"N", "S", "E", "W"};
		BoardNode[] wudvr = {new BoardNode(avatar.getX(), avatar.getY()+1), new BoardNode(avatar.getX(), avatar.getY()-1), new BoardNode(avatar.getX()+1, avatar.getY()), new BoardNode(avatar.getX()-1, avatar.getY())};
		dirs[BoardNode.N] = universe.getSymbol(avatar.getX(), avatar.getY()+1);
		dirs[BoardNode.S] = universe.getSymbol(avatar.getX(), avatar.getY()-1);
		dirs[BoardNode.E] = universe.getSymbol(avatar.getX()+1, avatar.getY());
		dirs[BoardNode.W] = universe.getSymbol(avatar.getX()-1, avatar.getY());
		//Random rand = new Random();
		//int i = rand.nextInt(4);
		int i=-1;
		for(int j=0; j<dirs.length; j++){
			if(dirs[j].equals(TheBoard.BASE) || dirs[j].equals(TheBoard.PLAIN)){
			//i = rand.nextInt(4);
				if(!universe.touredAlready(wudvr[j].getX(), wudvr[j].getY())){
					i=j;
					j = dirs.length;
				}
			}
		}
		if(i==-1){
			Random rand = new Random();
		  i = rand.nextInt(4);
			while(dirs[i].equals(TheBoard.WATER) || dirs[i].equals(TheBoard.WALL)){
				i =  rand.nextInt(4);
			}
		}
System.out.println("looking around:");
		String cmd = "1 Move " + ans[i];
		// ISSUE COMMAND BACK TO SERVER
		sendCommandToServer(cmd);
	}
	
	
	public void moveToNearestBase(){
		BoardNode currentPos = new BoardNode(avatar.getX(), avatar.getY());
		if(havePlan && ((BoardNode)currentPlan.getFirst()).equals(currentPos)){ // make sure plan is still accurate!
			//if(((BoardNode)currentPlan.getFirst()).equals(currentPos)){
				if(universe.getSymbol(avatar.getX(), avatar.getY()).equals(TheBoard.BASE)){
					//checkForDropCondition(GREEN);
					// i'm at the base!
					if(!dropAsManyPackagesAsPossible()){
						lookAround();
					}
				}else{
				currentPlan.removeFirst();
				// we are safe to bid $1
				String cmd = "1 Move ";
				BoardNode n = (BoardNode)currentPlan.getFirst();
				cmd += getDir(currentPos, n);
				// ISSUE COMMAND BACK TO SERVER
				sendCommandToServer(cmd);
				}
			//}
		}//don't have a plan!
		else{
			currentPlan = ShortestPath.getShortestPath(universe.getGraph(), currentPos, (BoardNode)universe.getBases().get(homeBase));
			havePlan = true;
			//moveToNearestBase();
			lookAround();
		}
	}
	
	private boolean dropAsManyPackagesAsPossible(){
		ArrayList l = getPackagesForBase(new BoardNode(avatar.getX(), avatar.getY()));
		String cmd = "5 Drop ";
		if(l.size()>0){
			Iterator it = l.iterator();
			while(it.hasNext()){
				ThePackage pkg = (ThePackage)it.next();
				cmd += pkg.getID() + " ";
			}
			sendCommandToServer(cmd);
			return true;
		}else{
			return false;
		}
	}
	
	
	// get direction from avatar of adjacent node
	private String getDir(BoardNode currentPos, BoardNode n){
		String cmd = "";
		if(n.getX()<currentPos.getX()){
			cmd+="W";
		}else{
			if(n.getX()>currentPos.getX()){
				cmd+="E";
			}else{
				if(n.getY()<currentPos.getY()){
						cmd+="N";
				}else{
					cmd+="S";
				}
			}
		}
		return cmd;
	}
	
	private boolean packagesPresent(){
		return availablePackages.size()>0;
	}
	
	// greed based on how much i can carry and the size of packages i've picked up
	// already
	private boolean feelGreedy(){
		if(mustDeliverPackages)
			return false;
		else
			return (avatar.getStrength() - avatar.getCarryingWeight()) > avatar.getAvgPackageWeight() * 1.10;
	}
	
	
	// yeah, i'm really going to solve a knapsack problem...whatever
	// just be greedy by taking as many small packages first, then big ones
	private void takePackagesIWant(){
		ArrayList taken = new ArrayList();
		ThePackage pkgs[] = new ThePackage[availablePackages.size()];
		for(int i=0; i<pkgs.length; i++){
			pkgs[i] = (ThePackage)availablePackages.get(i);
		}
		Arrays.sort(pkgs, new PackageWeightComparator());
		for(int i=0; i<pkgs.length; i++){
			if(pkgs[i].getWeight()+avatar.getCarryingWeight()<avatar.getStrength()){
				//if(pkgs[i].getDestination().equals((BoardNode)universe.getBases().get(homeBase))){
					taken.add(pkgs[i]);
				//}
			}
		}
		if(taken.size()>0){
			// i'm safe from threat, so just bid $1
			String cmd = "1 Pick ";
			for(int i=0; i<taken.size(); i++){
				cmd+= ((ThePackage)taken.get(i)).getID() + " ";
			}
			if(cmd.equals(lastPickCommand)){
				System.out.println("I can't seem to pick this stuff up, so i'll issue a delivery notice:");
				//lookAround();
				deliverPackages();
			}else{
				// ISSUE COMMAND BACK TO SERVER
				lastPickCommand = cmd;
				sendCommandToServer(cmd);
			}
		}else{
System.out.println("No packages to take so i'll:");
			lookAround();
		}
	}
	
	private void deliverPackages(){
		mustDeliverPackages = true;
		BoardNode key = null;
		int mx=0;
		if(avatar.getPackageCount()>0){
			Iterator it = universe.getBases().iterator();
			while(it.hasNext()){
				BoardNode tempkey = (BoardNode)it.next();
				int t = ((ArrayList)avatar.getKnapsack().getPackages(tempkey)).size();
				if(t>mx){
					mx=t;
					key = tempkey;
				}
			}
		}
		if(key!=null){
			homeBase = universe.getBases().indexOf(key);
			currentPlan = ShortestPath.getShortestPath(universe.getGraph(), new BoardNode(avatar.getX(), avatar.getY()), (BoardNode)universe.getBases().get(homeBase));
		}else{
	System.out.println("D'OH!  Must make a delivery, but don't have packages!");
			mustDeliverPackages = false;
			lookAround();
		}
	}
	
	// looks like a bug in test server, this is to check for it...
	String lastPickCommand = "";
	
	private void desireFight(){
		// i don't really know if i'm still on the plans path, but its a decent
		// enough heuristic (i hope)
		if(feelGreedy() && avatar.getMoney()>currentPlan.size()+5){
			pushAggressorBot();
		}else{
			desireFlee();
		}
	}
	
	// an emergency situation!
	public void desireFlee(){
		String[] dirs = new String[4];
		String[] ans = {"N", "S", "E", "W"};
		dirs[BoardNode.N] = universe.getSymbol(avatar.getX(), avatar.getY()+1);
		dirs[BoardNode.S] = universe.getSymbol(avatar.getX(), avatar.getY()-1);
		dirs[BoardNode.E] = universe.getSymbol(avatar.getX()+1, avatar.getY());
		dirs[BoardNode.W] = universe.getSymbol(avatar.getX()-1, avatar.getY());
		String cmd = "";
		for(int i=0; i<dirs.length; i++){
			if(dirs[i].equals(TheBoard.PLAIN) || dirs[i].equals(TheBoard.BASE)){
				//i = dirs.length;
				int bid = makeHiBid();
				cmd += bid + " Move " + ans[i];
				i = dirs.length;
			}
		}
		if(cmd.equals("")) // the "your screwed" case
			cmd += "1 Drop";
	System.out.println("FLEE!!!");
		sendCommandToServer(cmd);
	}
	
	// 
	private int makeHiBid(){
		int bid = 15;
		while(bid>(avatar.getMoney()-currentPlan.size())){
			bid--;
		}
		if(bid<=0)
			bid=1;
		return bid;
	}
	
	// pick one of the nearest bots at random and start acting like a jerk...
	public void pushAggressorBot(){
			BoardNode currentPos = new BoardNode(avatar.getX(), avatar.getY());
			Random rand = new Random();
			BoardNode n = (BoardNode)aggressors.get(rand.nextInt(aggressors.size()));
			String cmd = "5 Move ";
			cmd += getDir(currentPos, n);
			// ISSUE COMMAND BACK TO SERVER
			sendCommandToServer(cmd);
	}
	
	
	private ArrayList aggressors = new ArrayList();;
	// check if someone is near us, or we're near water
	private int checkThreats(){
		aggressors.clear();
		int threat = GREEN;
		int x = avatar.getX();
		int y = avatar.getY();
		Iterator it = botList.iterator();
		while(it.hasNext()){
			TheRobot r = (TheRobot)it.next();
			if((r.getX()-x==0 && Math.abs(r.getY()-y)==1) || (r.getY()-y==0 && Math.abs(r.getX()-x)==1)){
				threat = YELLOW;
				aggressors.add(new BoardNode(r.getX(), r.getY()));
			}
		}
		if(threat==YELLOW){
			if(universe.getSymbol(x, y+1).equals(TheBoard.WATER) || universe.getSymbol(x, y-1).equals(TheBoard.WATER) || universe.getSymbol(x+1, y).equals(TheBoard.WATER) || universe.getSymbol(x-1, y).equals(TheBoard.WATER))
				threat = RED;
		}
		return threat;
	}
	
	
	private void consultMap(){
		calcDistanceToBases();
	}
	
	
	// this gives a weighting to all the bases, and a fully ordered plan to the
	// nearest base
	private void calcDistanceToBases(){
		ArrayList paths = new ArrayList(baseWeights.length);
		BoardNode start = new BoardNode(avatar.getX(), avatar.getY());
		int smallest = 0;
		for(int i=0; i<baseWeights.length; i++){
			BoardNode dest = (BoardNode)universe.getBases().get(i);
			paths.add(i, ShortestPath.getShortestPath(universe.getGraph(), start, dest));
			baseWeights[i] = ((LinkedList)paths.get(i)).size();
			if(baseWeights[i]<baseWeights[smallest])
				smallest = i;
		}
		currentPlan = (LinkedList)paths.get(smallest);
		havePlan = true;
		homeBase = smallest;
	}
	
	
	
	public int interpretMessage(String msg){
		if(msg.startsWith("#", 0)){
			interpretTurnResponse(msg);
			return TURN;
		}else{
			interpretPackageList(msg);
			return PACKAGES;
		}
	}
	
	private void interpretTurnResponse(String msg){
		turnResponseInit();
		StringTokenizer botTokens = new StringTokenizer(msg, "#");
		// process each bot's info
		while(botTokens.hasMoreTokens()){
			StringTokenizer botInfo = new StringTokenizer(botTokens.nextToken());
			TheRobot robotID = new TheRobot(Integer.parseInt(botInfo.nextToken()));
			if(robotID.equals(avatar)){
				robotID=avatar;
			}
			while(botInfo.hasMoreTokens()){
				String s = botInfo.nextToken();
				if(s.equals("X")){
					handleBotData(robotID, botInfo);
				}else{
					if(s.equals("P")){
						handlePickedUp(robotID, botInfo);
					}else{
						if(s.equals("D")){
							handleDropped(robotID, botInfo);
						}else{
							handleBotMove(robotID, s);
						}
					}
				}
			}
		}
	}
	
	private void turnResponseInit(){
		Iterator it = botList.iterator();
		// shun all robots...
		while(it.hasNext()){
			((TheRobot)it.next()).setState(TheRobot.SHUN);
		}
	}
	
	
	private void handleBotData(TheRobot r, StringTokenizer st){
		r.setX(Integer.parseInt(st.nextToken()));
		st.nextToken();
		r.setY(Integer.parseInt(st.nextToken()));
		int idx = botList.indexOf(r);
		if(idx>=0){
			botList.set(idx, r);
		}else{
			botList.add(r);
		}
	}
	
	/*
	private void handlePickedUp(TheRobot r, StringTokenizer st){
		int idx = botList.indexOf(r);
		ThePackage pkg = new ThePackage(Integer.parseInt(st.nextToken()));
		if(idx>=0){
			((TheRobot)botList.get(idx)).pickUpPackage(pkg);
		}
	}
	*/
	
	private void handlePickedUp(TheRobot r, StringTokenizer st){
		ThePackage pkg = new ThePackage(Integer.parseInt(st.nextToken()));
		pkg = (ThePackage)knownPackages.get(knownPackages.indexOf(pkg));
		if(r.equals(avatar)){
			
			int idx = botList.indexOf(r);
			if(idx>=0){
				((TheRobot)botList.get(idx)).pickUpPackage(pkg);
			}
			
			avatar.pickUpPackage(pkg);
	//System.out.println(r.getID() + " should have picked up pkg: " + pkg.getID());
		}
		knownPackages.remove(pkg);
		knownPkgIndex.rem(pkg, new BoardNode(r.getX(), r.getY()));
	}
	
	private void handleDropped(TheRobot r, StringTokenizer st){
		ThePackage pkg = new ThePackage(Integer.parseInt(st.nextToken()));
		if(r.equals(avatar)){
			int idx = botList.indexOf(r);
			if(idx>=0){
				((TheRobot)botList.get(idx)).dropPackage(pkg);
			}
		}
		knownPackages.add(pkg);
		knownPkgIndex.addPackage(pkg, new BoardNode(r.getX(), r.getY()));
	}
	
	private void handleBotMove(TheRobot r, String dir){
		int idx = botList.indexOf(r);
		r = (TheRobot)botList.get(idx);
		boolean isAvatar = r.equals(avatar);
		BoardNode bn=null;
		if(dir.equals("N")){
			bn = r.moveNorth();
		}else{
			if(dir.equals("S")){
				bn = r.moveSouth();
			}else{
				if(dir.equals("E")){
					bn = r.moveEast();
				}else{
					if(dir.equals("W")){
						bn = r.moveWest();
					}
				}
			}
		}
		if(isAvatar && bn!=null)
			universe.toured(bn.getX(), bn.getY());
	}
	
	/////////////////
	// remember, package list might be empty
	private void interpretPackageList(String msg){
		availablePackages.clear();
		StringTokenizer st = new StringTokenizer(msg);
		while(st.hasMoreTokens()){
			int pkgID = Integer.parseInt(st.nextToken());
			int destX = Integer.parseInt(st.nextToken());
			int destY = Integer.parseInt(st.nextToken());
			int weight = Integer.parseInt(st.nextToken());
			ThePackage pkg = new ThePackage(pkgID, destX, destY, weight);
			availablePackages.add(pkg);
			knownPackages.add(pkg);
			knownPkgIndex.addPackage(pkg, new BoardNode(avatar.getX(), avatar.getY()));
		}
	}
	
}
