import java.util.*;

public class TheBoard{
	int height;
	int width;
	String[][] board;
	BoardGraph graph;
	ArrayList bases;
	
	public static final String PLAIN = ".";
	public static final String WATER = "~";
	public static final String WALL = "#";
	public static final String BASE = "@";
	
	public static final int UNCHARTED = 0;
	public static final int VISITED = 1;
	private int[][] tourGuide;
	
	
	public TheBoard(int height, int width, String[][] board){
		this.height=height; 
		this.width=width;
		this.board = board;
		bases = new ArrayList();
		graph = new BoardGraph(this);
		/*
		System.out.println(width + ", " + height);
		for(int i=0; i<height; i++){
			for(int j=0; j<width; j++){
				System.out.print(board[i][j] + " ");
			}
			System.out.print("\n");
		}
		*/
		tourGuide = new int[board.length][];
		for(int i=0; i<tourGuide.length; i++){
			tourGuide[i] = new int[board[i].length];
		}
	}
	
	public void toured(int x, int y){
		tourGuide[y][x] = VISITED;
	}
	
	public boolean touredAlready(int x, int y){
		return tourGuide[y][x] == VISITED;
	}
	
	public BoardGraph getGraph(){return graph;}
	
	public void acknowledgeBase(BoardNode location){
		bases.add(location);
	}
	
	public ArrayList getBases(){return bases;}
	
	public int getHeight(){return height;}
	public int getWidth(){return width;}
	public String[][] getBoard(){return board;}
	
	public String getSymbol(int x, int y){return board[y][x];}
	
	public TheBoard copy(){
		String[][] boardCopy = new String[height+2][width+2];
		for(int i=0; i<height+2; i++){
			System.arraycopy(board, 0, boardCopy[i], 0, width+2);
		}
		return new TheBoard(height, width, boardCopy);
	}
	
	public String toString(){
		StringBuffer buf = new StringBuffer("");
		buf.append("width="+width+", height:"+height+"\n");
//System.out.println(width + ", " + height);
		for(int i=1; i<=height; i++){
			for(int j=1; j<=width; j++){
				buf.append(board[i][j] + " ");
//System.out.print(board[i][j] + " ");
			}
			buf.append("\n");
		}
		return buf.toString();
	}
	
}
