// a go at the client thread
import java.net.*;
import java.io.*;
import java.util.*;

public class TheMain implements Runnable{
	private Socket socket = null;
	private Thread runner = null;
	//private TheBoard board = null;
	//private TheRobot robot = null;
	
	private static TheRobot buildRobot(BufferedReader buf)throws IOException, InterruptedException{
		StringTokenizer st = nextLine(buf);
		return new TheRobot(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));
	}
	
	private static TheBoard buildBoard(BufferedReader buf)throws IOException, InterruptedException{
		StringTokenizer st = nextLine(buf);
		int width = Integer.parseInt(st.nextToken());
		int height = Integer.parseInt(st.nextToken());
		String[][] board = new String[height+2][width+2];
		for(int i=0; i<height+2; i++){
			Arrays.fill(board[i], "#");
		}
		for(int i=1; i<=height; i++){
			st = nextLine(buf);
			String line = st.nextToken();
			for(int j=1; j<=width; j++){
				board[i][j]=String.valueOf(line.charAt(j-1));
			}
		}
		return new TheBoard(height, width, board);
	}
	
	private static StringTokenizer nextLine(BufferedReader buf) throws IOException, InterruptedException{
		//while(true){
			//if(buf.ready()){
				return new StringTokenizer(buf.readLine());
			/*
			}else{
				//System.out.print("*");
				Thread.sleep(200);
			}
		}
		*/
	}
	
	
	public synchronized void connect2server(String host, int port){
		socket = null;
		try{
			socket=new Socket(host, port);
		}catch(UnknownHostException uhe){
			System.err.println("i don't recognize the host: " + host);
			System.exit(1);
		}catch(IOException ioe){
			System.err.println("An I/O exception happened....:");
			ioe.printStackTrace();
			System.exit(1);
		}catch(SecurityException se){
			System.err.println("Good god!  Arrgghh... i've been hit by a SecurityException!");
			System.err.println("This might prove difficult to fix depending on your local setup;");
			se.printStackTrace();
			System.exit(1);
		}
		runner = new Thread(this);
		runner.start();
	}
	
	public void run(){
		BufferedWriter out = null;
		if(socket!=null){
			BufferedReader buf = null;
			try{
				out = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));
				//Writer out= new OutputStreamWriter(socket.getOutputStream());
				//String p = "Player";
				//out.write(p.toCharArray());
				out.write("Player\n");
				out.flush();
				//out.close();
				buf = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			}catch(IOException ioe){
				System.err.println("An I/O exception happened....:");
				ioe.printStackTrace();
				System.exit(1);
			}
			// The main proper...
			TheBoard board=null;
			TheRobot robot=null;
			//while(true){
				try{
					boolean connected = false;
					System.out.println("waiting for reply from server...");
					while(!connected){
						if(buf.ready()){
							System.out.println("\n!! ALL YOUR BASE ARE BELONG TO US !!\n");
							connected = true;
						}else{
							System.out.print("*");
							Thread.sleep(200);
							//buf.wait();
						}
					}
					board = buildBoard(buf);
					robot = buildRobot(buf);
					System.out.println(board);
					System.out.println(robot);
					GamePlay game = new GamePlay(robot, board, out);
					// pass all the messages from server to client
					while(true){
						String msg = buf.readLine();
						System.out.println(msg);
						game.passMessage(msg);
					}
				}catch(InterruptedException ie){
					System.err.println("i've been rudely interrupted!");
					ie.printStackTrace();
					System.exit(1);
				} catch(IOException ioe){
					System.err.println("An I/O exception happened....:");
					ioe.printStackTrace();
					System.exit(1);
				}
			//}
		}//
	}

	public static void main(String[] a){
		// make sure we got the name and port
		if(a.length<2){
			System.err.println("wrong number of arguments.");
		}else{
			String host = a[0];
			int port=0;
			try{
				port = Integer.parseInt(a[1]);
			}catch(NumberFormatException ne){
				System.err.println("Bad argument for port number.");
				System.exit(1);
			}
			TheMain tm = new TheMain();
			tm.connect2server(host, port);
			//System.err.println("i feel strangely ill...");
		}
	}
	
}
