import java.util.*;

public class TheRobot{
	
	private int ID;
	private int strength;
	private int money;
	private int x, y;
	private int state;
	public static final int BLESS=0;
	public static final int SHUN =1;
	private ArrayList packages;
	private int carryingWeight;
	// my knapsack has many compartments...
	private PackageTable knapsack;
	
	public TheRobot(int ID, int strength, int money){
		this.ID = ID;
		this.strength = strength;
		this.money = money;
		x=y=0;
		state = BLESS;
		packages = new ArrayList();
		knapsack = new PackageTable();
	}
	
	public TheRobot(int ID){
		this(ID, 0, 0);
	}
	
	public PackageTable getKnapsack(){return knapsack;}
	
	public ArrayList getPackageList(){return packages;}
	
	public int getPackageCount(){return packages.size();}
	
	public void pickUpPackage(ThePackage pkg){
		if(!packages.contains(pkg)){
			packages.add(pkg);
			knapsack.addPackage(pkg);
			carryingWeight+=pkg.getWeight();
		}
		money--;
	}
	
	public void dropPackage(ThePackage pkg){
		if(packages.contains(pkg)){
			int idx = packages.indexOf(pkg);
			knapsack.rem(pkg, ((ThePackage)packages.get(idx)).getDestination());
			packages.remove(pkg);
			carryingWeight-=pkg.getWeight();
		}
		money--;
	}
	
	public int getCarryingWeight(){return carryingWeight;}
	public int getStrength(){ return strength;}
	// this is a hack for something else...
	public void setStrength(int s){strength = s;}
	
	
	public double getAvgPackageWeight(){
		double avg = 0;
		Iterator it = packages.iterator();
		while(it.hasNext()){
			avg += ((ThePackage)it.next()).getWeight();
		}
		if(packages.size()>0)
			return avg/packages.size();
		else
			return 0;
	}
	
	// in a state of BLESS or SHUN
	public void setState(int state){this.state=state;}
	public int getState(){return state;}
	
	
	public void setX(int x){this.x=x;}
	public int getX(){return x;}
	
	public void setY(int y){this.y=y;}
	public int getY(){return y;}
	
	public int getMoney(){return money;}

	
	public boolean equals(Object o){
		if(o instanceof TheRobot){
			TheRobot r = (TheRobot)o;
			return ID==r.ID;
		}else{
			return false;
		}
	}
	
	public int getID(){return ID;}
	
	public String toString(){
		return "ID:"+ID+", strength:"+strength+", money:"+money+", X:"+x+", Y:"+y;
	}
	
	public BoardNode moveEast(){
		++x;
		money--;
		return new BoardNode(x,y);
	}
	public BoardNode moveWest(){
		--x;
		money--;
		return new BoardNode(x,y);
	}
	public BoardNode moveNorth(){
		++y;
		money--;
		return new BoardNode(x,y);
	}
	public BoardNode moveSouth(){
		--y;
		money--;
		return new BoardNode(x,y);
	}
	
}
